
BINDING_HEADER_POPUPACTIONS = "SwitchBar Action Bars";
_G["BINDING_NAME_CLICK Switchbar:sb1"] = "Toggle bar 1";
_G["BINDING_NAME_CLICK Switchbar:sb2"] = "Toggle bar 2";
_G["BINDING_NAME_CLICK Switchbar:sb3"] = "Toggle bar 3";
_G["BINDING_NAME_CLICK Switchbar:sb4"] = "Toggle bar 4";
_G["BINDING_NAME_CLICK Switchbar:sb5"] = "Toggle bar 5";
_G["BINDING_NAME_CLICK Switchbar:sb6"] = "Toggle bar 6";
_G["BINDING_NAME_CLICK Switchbar:sb7"] = "Toggle bar 7";
_G["BINDING_NAME_CLICK Switchbar:sb8"] = "Toggle bar 8";
_G["BINDING_NAME_CLICK Switchbar:sb9"] = "Toggle bar 9";
_G["BINDING_NAME_CLICK Switchbar:sb10"] = "Toggle bar 10";
_G["BINDING_NAME_CLICK Switchbar:sb11"] = "Toggle bar 11";
_G["BINDING_NAME_CLICK Switchbar:sb12"] = "Toggle bar 12";
_G["BINDING_NAME_CLICK Switchbar_Wrap:showhide"] = "Toggle Movetab";

print("Switchbar loaded");

local HDRW = CreateFrame("Button", "Switchbar_Wrap", UIParent, "SecureHandlerClickTemplate");
--HDRW:RegisterForClicks("AnyDown","AnyUp");
HDRW:SetFrameStrata("DIALOG");
HDRW:SetWidth(80);
HDRW:SetHeight(40);
HDRW:SetMovable(true);
HDRW:ClearAllPoints();
HDRW:SetPoint("CENTER", UIParent, "CENTER", 0, -100);
HDRW:Hide();

local HDR = CreateFrame("Button", "Switchbar", UIParent, "SecureHandlerClickTemplate");
HDR:RegisterForClicks("AnyDown","AnyUp");
HDR:SetFrameStrata("DIALOG");
HDR:SetWidth(1);
HDR:SetHeight(1);
HDR:SetMovable(false);
HDR:ClearAllPoints();
HDR:SetPoint("TOPLEFT", HDRW, "BOTTOMLEFT", 2, 0);
HDR:Hide();

local FillTexture = HDRW:CreateTexture(nil, "BACKGROUND");
FillTexture:SetAllPoints(HDRW);
FillTexture:SetTexture(0,0,0);
FillTexture:SetAlpha(0.8);

local LabelFontString = HDRW:CreateFontString(nil, "OVERLAY");
LabelFontString:SetWidth(50);
LabelFontString:SetFontObject(GameFontNormalSmall);
LabelFontString:SetJustifyH("RIGHT");
LabelFontString:SetPoint("CENTER", FillTexture, "CENTER", -10, 0);
LabelFontString:SetText("PULL");

HDRW:SetScript("OnMouseDown",
              function(self, button, down)
				  if (button == "showhide") then
					  self:Show();
                  elseif (button == "LeftButton") then
                      self:StartMoving();
                  end
              end);
HDRW:SetScript("OnMouseUp",
              function(self, button)
				  if (button == "showhide") then
					  self:Hide();
                  elseif (button == "LeftButton") then
                      self:StopMovingOrSizing();
                  end
              end);

HDR:Execute([[
					buttons = newtable();
					keys = newtable();
            ]]);

local getBindingKey = GetBindingKey;

HDR:SetAttribute("_onclick",
                 [[
					if (down) then
						bar = string.sub(button, 3);
						for idx, button in ipairs(buttons) do
							button:SetAttribute("action", 12 * (bar - 1) + idx);
							key1, key2 = GetBindingKey("ACTIONBUTTON"..idx);
							if (key1 ~= nil) then self:SetBindingClick(false, key1, button); end
							if (key2 ~= nil) then self:SetBindingClick(false, key2, button); end
						end
						self:Show();
					else 
						self:Hide();
						self:ClearBindings();
					end;
                 ]]);

for i = 1, 12 do
    local NA = CreateFrame("CheckButton",
                           "Switchbar_Action" .. i,
                           HDR,
                           "ActionBarButtonTemplate");
    NA:SetFrameStrata("DIALOG");
    NA:SetScale(1);
    NA:SetSize(27, 27);
	if (i == 1) then
    NA:SetPoint("TOPLEFT", HDR, "BOTTOMLEFT", (39) * (i - 1) , -2);
	else
    NA:SetPoint("LEFT", NA2, "RIGHT", 4 , 0);
	end
	
    local NN = NA:CreateFontString(nil, "OVERLAY");
    NN:SetFontObject(NFO);
    NN:SetPoint("CENTER", NA, "BOTTOM");
    --NN:SetText(i % 12);
    NA:SetAttribute("type", "action");

    HDR:SetFrameRef("kid", NA);
    HDR:Execute("buttons[" .. i .. "] = self:GetFrameRef('kid'); buttons[" .. i .. "]:Show()");
    HDR:WrapScript(NA, "OnClick",
                   [[
                    ]]);
	NA2 = NA;
end